#!/bin/bash
#
# simplification of automated mem-tests
#   to find bad DIMM by replacing log2-groups of DIMMs   # 2018-09
#
#  better BIOS.ECC=of for faster results?
#
NODE=$(hostname -s)
LOGFILE=mem_badram_${NODE}.log    # log to local DIR=/home/user/
# ToDo: save old different logfiles (yearly?) 
YY=$(date +%y)
if [ ! -r $LOGFILE.first ];then LOGFILE="$LOGFILE.first";fi
#exec 1> $LOGFILE 2>&1   # >> = anhaengen, > = overwrite
exec &> >(tee "$LOGFILE")
#
if [ "$UID" != "0" ];then echo "WARNING: dmidecode needs root, skip ...";else
# system-Unterscheidung + DIMM-SN-logging
dmidecode --type system | grep -e "Product Name" -e "Serial Number"
# 2018.t100.node.cXXX = RS720Q-E8-RS12
dmidecode --type memory | grep -e "Manufa" -e "Part Num" -e "Size" | sort -u
echo "NumDIMMs: $(dmidecode --type memory | grep -c -e "Part Num")"
dmidecode --type memory | grep -e "Serial Number" # do not sort!
fi
#
# next lines are cluster-specifique
# ToDo: detect numNodes + nim numCPUperNode
xx=$(numactl --hardware)   # info for parameter-decision (ToDo automated)
numNodes=$(echo "$xx"|awk '/^available/ && /node/{print $2}')
maxSockCore=$(echo "$xx"|awk '/^node 0 cpus:/{for(i=4;i<=NF;i++)\
{if($i==0 || $i==z+1)z=$i}print z}')  # 7 for 8 cores/node
echo "numNodes=$numNodes maxSockCore=$maxSockCore"
export OMP_NUM_THREADS=$[maxSockCore+1]
# ToDo do not test at first logfile?
for ((x=0;x<$numNodes;x++));do
 mincore=$[(maxSockCore+1)*x]
 maxcore=$[mincore+maxSockCore]
 size=$(echo "$xx"|awk '/^node 0 size/{print $4}')
 echo "$(date +%y%m%d-%H%M) test cpu $x of (0-$[numNodes-1]), Core=$mincore-$maxcore size/MB=$size-8000"
 GOMP_CPU_AFFINITY="$mincore-$maxcore"\
  numactl -m $x ./mem_badram $[size-8000] -l2 $1
done
